%{
#include <string.h>
#include "jmmc.tab.h"

int riadok = 1;
int it, ik;
extern YYSTYPE yylval;
int yywrap(void);

/* TABULKA KLUCOVYCH SLOV a ich kodov */
struct { char *txt; int kod; } ks[] = {
    "boolean",  BOOLEAN,
    "double",   DOUBLE,
    "int",      INT,
    "long",     LONG,
    "void",     VOID,
    "public",   PUBLIC,
    "protected",PROTECTED,
    "private",  PRIVATE,
    "static",   STATIC,
    "final",    FINAL,
    "abstract", ABSTRACT,
    "native",   NATIVE,
    "class",    CLASS,
    "constructor",CONSTRUCTOR,
    "extends",  EXTENDS,
    "implements",IMPLEMENTS,
    "import",   IMPORT,
    "new",      NEW,
    "this",     THIS,
    "super",    SUPER,
    "return",   RETURN,
    "if",       IF,
    "else",     ELSE,
    "while",    WHILE,
    "null",     NULL_LITERAL,
    "true",     TRUE_LITERAL,
    "false",    FALSE_LITERAL,
    "for",      FOR,
    NULL,       0
};

%}

P           [a-zA-Z]
C           [0-9]
IDENT       {P}({P}|{C})*
CIS         {C}+
BIELY       [ \t]
KOMENTAR     "//".*
NR          \n|\r|\r\n
%%
","         return CIARKA;
";"         return BCIARKA;
"("         return LOZAT;
")"         return POZAT;
"{"         return LZZAT;
"}"         return PZZAT;
"["         return LHZAT;
"]"         return PHZAT;
"."         return BODKA;
"="         return ROVNE;
"+"         return PLUS;
"-"         return MINUS;
"*"         return KRAT;
"/"         return DEL;
"<"         return LT;
"<="        return LE;
">"         return GT;
">="        return GE;
"=="        return EQ;
"!="        return NE;
"||"        return OR;
"&&"        return AND;
\"[^"\n]*\" {
                yytext[yyleng-1] = 0;
                yylval.txt = strdup(&yytext[1]);
                return STR_LITERAL;
            }
{IDENT}     {   /* test na klucove slovo */
                for (ik = 0; ks[ik].txt != NULL; ik++)
                    if (strcmp(ks[ik].txt, yytext) == 0)
                        return ks[ik].kod;
                /* test na meno triedy */
                for (it = 0; it <= ix_tr; it++)
                    if (strcmp (triedy[it].menoTr, yytext) == 0) {
                        yylval.ihod = it;
                        return TRIEDA;
                    }
                yylval.meno = strdup(yytext);
                return ID;
            }
{CIS}       { sscanf(yytext, "%d", &yylval.ihod); return INT_LITERAL; }
{CIS}"."{CIS} { sscanf(yytext, "%lf", &yylval.dhod); return DBL_LITERAL; }
{BIELY}     ;
{KOMENTAR}  ;
{NR}        { riadok++; }
.           { xxerror("Nedovoleny znak: ", yytext); }
%%

int yywrap(void)
{
    return 1;
}

